<template>
	<section>
		<h1>Crea</h1>
		<b-field label="Quesito elezione">
      		<b-input v-model="question"></b-input>
    	</b-field>
        <b-field label="Data e Ora di Inizio">
            <b-datetimepicker
            	v-model="dateTimeStart"
                placeholder="Seleziona data e ora...."
                icon="calendar-today"
                editable>
            </b-datetimepicker>
        </b-field>
        <b-field label="Data e Ora di Fine">
            <b-datetimepicker
            	v-model="dateTimeEnd"
                placeholder="Seleziona data e ora...."
                icon="calendar-today"
                editable>
            </b-datetimepicker>
        </b-field>
        <b-button @click="deployContract()">Invia</b-button>

        <section v-if="this.contractDeployed">
			<p>Contratto lanciato</p>
        	<br>
        	<b-button 
        		type="is-info"
        		tag="a"
                :href="'https://ropsten.etherscan.io/address/' + this.contractAddress"
                target="_blank"
        	>
        		Guarda su Etherscan
        	</b-button>        	
        </section>


		<stack-modal
    		:show="show"
    	    title="Dummy auth with Smart Card"
    	    @close="show=false"
    	    :modal-class="{ ['modal-xl']: true }"
    	    :save-button="{
    	    	visible: false
    	    }"
    	>
    		<div class="container">
    			<b-button type="is-success" @click="completeAuth()">Completa l'autenticazione</b-button>
    			<b-button type="is-danger" @click="authenticationError()">Fallisci l'autenticazione</b-button>
			</div>
    	</stack-modal>
	</section>
</template>

<script>
	import { ethers } from 'ethers'
	import Contract from '../../static/contracts/Voting.json'
	import StackModal from '@innologica/vue-stackable-modal'

	export default {
		layout: 'none',

		components: {
			StackModal,
		},

		mounted() {
			
		},

		methods: {
			deployContract: function() {
				this.show = true
				//this.question = this.getTimestamp(this.dateTimeStart)
			},

			authenticationError() {
				this.show = false
                const notif = this.$buefy.notification.open({
                    duration: 5000,
                    message: `Autenticazione fallita!`,
                    position: 'is-bottom-right',
                    type: 'is-danger',
                    hasIcon: true
                })
            },

			completeAuth: async function () {
				const provider = new ethers.providers.Web3Provider(window.web3.currentProvider)
      			await ethereum.enable()
      			const signer = provider.getSigner()
				this.show = false
				this.loadingComponent = this.$buefy.loading.open()

				this.startTimestamp = Math.round(this.dateTimeStart.getTime() / 1000)
				this.endTimestamp = Math.round(this.dateTimeEnd.getTime() / 1000)

				const votingContractFactory = new ethers.ContractFactory(Contract.abi, Contract.bytecode, signer)
				const VotingContract = await votingContractFactory.deploy(
					'dummyKey',
					 this.startTimestamp,
					 this.endTimestamp
				)

				const setQuestionMethodCall = await VotingContract.setQuestion(this.question)
				const addYesOptionMethodCall = await VotingContract.addOption('SI')
				const addNoOptionMethodCall = await VotingContract.addOption('NO')

				await setQuestionMethodCall.wait()
				await addYesOptionMethodCall.wait()
				await addNoOptionMethodCall.wait()

				this.contractAddress = VotingContract.address
				this.contractDeployed = true
				this.loadingComponent.close()

				//const question = await VotingContract.getQuestion()
				//const yesOption = await VotingContract.getOption(0)
				//const noOption = await VotingContract.getOption(1)

				//if (question == newQuestion && yesOption == 'YES' && noOption == 'NO') {
				//	alert('DONE')
				//} else {
				//	alert('Error')
				//}
			},
			getTimestamp: async function(date) {
				return await date.getTime()
			}
		},

		data() {
			return {
				startTimestamp: 0,
				endTimestamp: 0,
				loadingComponent: null,
				contractDeployed: false,
				contractAddress: '',
				show: false,
				question: '',
				dateTimeStart: new Date(Date.now() + (10 * 60 * 1000)),
				dateTimeEnd: new Date(Date.now() + (24 * 60 * 60 * 1000)),
			}
		}
	}
</script>

<style>
    @import "https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css";
</style>

<style lang="scss">
    @import "../../node_modules/@innologica/vue-stackable-modal/src/assets/transitions/translate-fade.scss";
    @import "../../assets/scss/modal.scss";
</style>